# -*- coding: utf-8 -*-

import sys
import math
import csv
import types
import PyQt5.QtCore as core
import PyQt5.QtWidgets as widgets
import PyQt5.uic as uic

app = widgets.QApplication(sys.argv)
w = uic.loadUi("gesten.ui")
points = []
training = []
trainingSchwerpunkte = []
trainingSD = []

def handleEvents(self, event):
    global points
    if event.type() == core.QEvent.MouseMove:
        points.append(event.pos())
    elif event.type() == core.QEvent.MouseButtonRelease:
        xSumme = 0
        ySumme = 0
        x2Summe = 0
        y2Summe = 0
        for p in points:
            xSumme += p.x()
            ySumme += p.y()
            x2Summe += p.x() ** 2
            y2Summe += p.y() ** 2
        xm = xSumme / len(points)
        ym = ySumme / len(points)
        sd = math.sqrt(x2Summe / len(points) - xm * xm + y2Summe / len(points) - ym * ym)
        for i in range(len(training)):
            summeDist = 0.0
            for j in range(len(training[i])):
                k = int(round((len(points)-1) * j / (len(training[i])-1)))
                pAktuell = (points[k] - core.QPointF(xm, ym)) / sd
                pMuster = (training[i][j] - trainingSchwerpunkte[i]) / trainingSD[i]
                pDiff = pAktuell - pMuster
                dist = math.sqrt(pDiff.x() ** 2 + pDiff.y() ** 2)
                summeDist += dist
            mittlAbst = summeDist / len(training[i])
            print(mittlAbst)
        points = []
    return True

w.widget.event = types.MethodType(handleEvents, w.widget)
f = open("mausgesten.csv", "r")
reader = csv.reader(f, delimiter = ',')
g = []
xSumme = 0
ySumme = 0
x2Summe = 0
y2Summe = 0
for row in reader:
    if int(row[0]) < 0:
        xm = xSumme / len(g)
        ym = ySumme / len(g)
        trainingSchwerpunkte.append(core.QPointF(xm, ym))
        trainingSD.append(math.sqrt(x2Summe / len(g) - xm * xm + y2Summe / len(g) - ym * ym))
        training.append(g)
        g = []
        xSumme = 0
        ySumme = 0
        x2Summe = 0
        y2Summe = 0        
    else:
        x = int(row[0])
        y = int(row[1])
        g.append(core.QPoint(x, y))
        xSumme += x
        ySumme += y
        x2Summe += x * x
        y2Summe += y * y
f.close()
w.show()
sys.exit(app.exec_())